## feel++ 0.91.0~svn7063

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
cmake_minimum_required (VERSION 2.6)

# guard against in-source builds

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt. ")
endif()

# guard against bad build-type strings

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(    NOT cmake_build_type_tolower STREQUAL "debug"
   AND NOT cmake_build_type_tolower STREQUAL "release"
   AND NOT cmake_build_type_tolower STREQUAL "relwithdebinfo")
  message(FATAL_ERROR "Unknown build type \"${CMAKE_BUILD_TYPE}\". Allowed values are Debug, Release, RelWithDebInfo (case-insensitive).")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_CXX_FLAGS "-std=c++0x" CACHE STRING "Default flags" FORCE)
  SET(CMAKE_CXX_FLAGS_DEBUG "-std=c++0x -g" CACHE STRING "Debug flags" FORCE)
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -g0 -O2 -DNDEBUG" CACHE STRING "Release flags" FORCE)
endif(CMAKE_COMPILER_IS_GNUCXX)

#SET( CMAKE_CXX_FLAGS "-pipe -Wall -O2 ")
#SET( CMAKE_C_FLAGS "-pipe -Wall -O2")

project (Feel++ C CXX Fortran)

OPTION(FEEL_ENABLE_SVN "enable Feel++ looking up for svn information" ON)
SET(FEEL_SCM "svn")
FIND_PACKAGE(Subversion)
IF(FEEL_ENABLE_SVN AND ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn ) )
#IF ( Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn )
  Subversion_WC_INFO(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Current revision is ${Project_WC_REVISION}")
  Subversion_WC_LOG(${PROJECT_SOURCE_DIR} Project)
  MESSAGE("Last changed log is ${Project_LAST_CHANGED_LOG}")
ELSE()
  FIND_PACKAGE(Git)
  if(FEEL_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git )

    execute_process(
      COMMAND git rev-parse --verify -q --short git-svn
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE GIT_COMMIT
      ERROR_VARIABLE GIT_COMMIT_error
      RESULT_VARIABLE GIT_COMMIT_result)
    if ( NOT ${GIT_COMMIT_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git rev-parse --verify -q --short git-svn\" failed with output:\n${GIT_COMMIT_error}")
    else()
      STRING(STRIP "${GIT_COMMIT}" GIT_COMMIT )
      MESSAGE(STATUS "Git commit: ${GIT_COMMIT}")
    endif()
    execute_process(
      COMMAND git show --raw ${GIT_COMMIT}
#      COMMAND "grep git-svn-id"
#      COMMAND sed -re "s/^\\s*git-svn-id: .*@([0-9]+).*$/\\1/"
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
      OUTPUT_VARIABLE SVN_COMMIT
      ERROR_VARIABLE Project_WC_REVISION_error
      RESULT_VARIABLE Project_WC_REVISION_result)
    if ( NOT ${Project_WC_REVISION_result} EQUAL 0 )
      MESSAGE(SEND_ERROR "Command \"git show --raw ${GIT_COMMIT}\" failed with output:\n${Project_WC_REVISION_error}")
    endif()
    string(REGEX REPLACE ".*git-svn-id: .*trunk@([0-9]+) .*" "\\1"Project_WC_REVISION ${SVN_COMMIT})
    MESSAGE(STATUS "Current SVN(git) revision is ${Project_WC_REVISION}")
  endif()
ENDIF()

set(FEEL_VERSION_MAJOR "0")
set(FEEL_VERSION_MINOR "91")
set(FEEL_VERSION_MICRO "0")
if ((FEEL_ENABLE_SVN AND Subversion_FOUND AND EXISTS ${PROJECT_SOURCE_DIR}/.svn) OR
    (FEEL_ENABLE_SVN AND GIT_FOUND AND  EXISTS ${PROJECT_SOURCE_DIR}/.git ))
  set(FEEL_VERSION_EXTRA "~${FEEL_SCM}${Project_WC_REVISION}")
  set(FEEL_REVISION "${Project_WC_REVISION}")
  set(FEEL_BUILDID "${Project_WC_REVISION}")
  file(WRITE "${CMAKE_SOURCE_DIR}/SVNREVISION" "${Project_WC_REVISION}")
else()
  set(FEEL_VERSION_EXTRA "")
  if ( EXISTS "${CMAKE_SOURCE_DIR}/SVNREVISION" )
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEEL_REVISION)
    file(READ "${CMAKE_SOURCE_DIR}/SVNREVISION" FEEL_BUILDID)
  else()
    set(FEEL_REVISION "0")
    set(FEEL_BUILDID "0")
  endif()
endif()
set(FEEL_VERSION "(((${FEEL_VERSION_MAJOR}) << 16) | ((${FEEL_VERSION_MINOR}) << 9) | (${FEEL_VERSION_MICRO}))" )
set(FEEL_VERSION_STRING "${FEEL_VERSION_MAJOR}.${FEEL_VERSION_MINOR}.${FEEL_VERSION_MICRO}${FEEL_VERSION_EXTRA}")
set(FEEL_SHARED_VERSION "1.0.0" )
set(FEEL_SHARED_SOVERSION "1" )

SET(FEEL_HOME_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEEL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
SET(FEEL_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE INTERNAL "")

SET( CMAKE_MODULE_PATH  ${FEEL_HOME_DIR}/cmake/modules )
add_subdirectory(cmake/modules)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

OPTION(ENABLE_MOVE_SEMANTICS "enable move semantics(elision)" ON )
MARK_AS_ADVANCED(ENABLE_MOVE_SEMANTICS)
IF ( ENABLE_MOVE_SEMANTICS )
  SET( BOOST_UBLAS_MOVE_SEMANTICS 1 CACHE STRING "Enable Boost Ublas move semantics" FORCE )
  ADD_DEFINITIONS( -DBOOST_UBLAS_MOVE_SEMANTICS )
ENDIF( ENABLE_MOVE_SEMANTICS)

OPTION(ENABLE_INSTANTIATION_MODE "Instantiation mode" ON )
MARK_AS_ADVANCED(ENABLE_INSTANTIATION_MODE)
IF ( ENABLE_INSTANTIATION_MODE )
  SET( FEEL_INSTANTIATION_MODE 1 )
ENDIF()

OPTION(FEEL_BENCHMARK_FLAGS "enable benchmarks flags" OFF)
if ( FEEL_BENCHMARK_FLAGS )
  set(CMAKE_BUILD_TYPE Release )
  SET(CMAKE_CXX_FLAGS_RELEASE "-std=c++0x -O3 -DNDEBUG --param max-inline-recursive-depth=32 --param max-gcse-passes=3 --param max-gcse-memory=8000 --param max-inline-insns-single=2000" CACHE STRING "Release flags" FORCE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  option(FEEL_ENABLE_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(FEEL_ENABLE_SSE2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    message(STATUS "Enabling SSE2 in tests/examples")
  endif()

  option(FEEL_ENABLE_SSE3 "Enable/Disable SSE3 in tests/examples" OFF)
  if(FEEL_ENABLE_SSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
    message(STATUS "Enabling SSE3 in tests/examples")
  endif()

  option(FEEL_ENABLE_SSSE3 "Enable/Disable SSSE3 in tests/examples" OFF)
  if(FEEL_ENABLE_SSSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
    message(STATUS "Enabling SSSE3 in tests/examples")
  endif()

  option(FEEL_ENABLE_SSE4_1 "Enable/Disable SSE4.1 in tests/examples" OFF)
  if(FEEL_ENABLE_SSE4_1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    message(STATUS "Enabling SSE4.1 in tests/examples")
  endif()

  option(FEEL_ENABLE_SSE4_2 "Enable/Disable SSE4.2 in tests/examples" OFF)
  if(FEEL_ENABLE_SSE4_2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
    message(STATUS "Enabling SSE4.2 in tests/examples")
  endif()

  option(FEEL_ENABLE_ALTIVEC "Enable/Disable AltiVec in tests/examples" OFF)
  if(FEEL_ENABLE_ALTIVEC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -mabi=altivec")
    message(STATUS "Enabling AltiVec in tests/examples")
  endif()

  option(FEEL_ENABLE_NEON "Enable/Disable Neon in tests/examples" OFF)
  if(FEEL_ENABLE_NEON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfloat-abi=softfp -mfpu=neon -mcpu=cortex-a8")
    message(STATUS "Enabling NEON in tests/examples")
  endif()
endif(CMAKE_COMPILER_IS_GNUCXX)
#INCLUDE(PackageArchGlobalMacros)
# INCLUDE(FeelGlobalMacros)
#INCLUDE(AdvancedSet)
#INCLUDE(AdvancedOption)


INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCXXSourceCompiles)
INCLUDE(CheckLibraryExists)
# INCLUDE(parse_arguments)

# MACRO(CAR var)
#   SET(${var} ${ARGV1})
# ENDMACRO(CAR)

# MACRO(CDR var junk)
#   SET(${var} ${ARGN})
# ENDMACRO(CDR)
INCLUDE(CheckTypeSize)
CHECK_TYPE_SIZE(int SIZE_INT )
CHECK_TYPE_SIZE(uint SIZE_UINT )
CHECK_TYPE_SIZE(size_t SIZE_SIZE_T )
CHECK_TYPE_SIZE(long SIZE_LONG )
CHECK_TYPE_SIZE(float SIZE_FLOAT )
CHECK_TYPE_SIZE(double SIZE_DOUBLE )
CHECK_TYPE_SIZE("long double" SIZE_LONG_DOUBLE)
MESSAGE(STATUS "SIZE_INT=${SIZE_INT}")
MESSAGE(STATUS "SIZE_UINT=${SIZE_UINT}")
MESSAGE(STATUS "SIZE_SIZE_T=${SIZE_SIZE_T}")
MESSAGE(STATUS "SIZE_LONG=${SIZE_LONG}")
MESSAGE(STATUS "SIZE_FLOAT=${SIZE_FLOAT}")
MESSAGE(STATUS "SIZE_DOUBLE=${SIZE_DOUBLE}")
MESSAGE(STATUS "SIZE_LONG_DOUBLE=${SIZE_LONG_DOUBLE}")


FIND_PACKAGE(Feel++ REQUIRED)

#
# Python
#
FIND_PACKAGE(PythonInterp 2.2 REQUIRED)

#
# Feel
#
ADD_SUBDIRECTORY ( feel )




SET(FEEL_MESH_MAX_ORDER "5" CACHE STRING "maximum geometrical order in templates to instantiate" )

OPTION(FEEL_ENABLE_DOCUMENTATION "enable feel documentation" OFF)
OPTION(FEEL_ENABLE_BENCHMARKS "enable feel benchmarks" OFF)
OPTION(FEEL_ENABLE_EXAMPLES "enable feel examples" OFF)
OPTION(FEEL_ENABLE_APPLICATIONS "enable feel applications" OFF)
OPTION(FEEL_ENABLE_RESEARCH "enable feel research" OFF)
OPTION(FEEL_ENABLE_TESTS "enable feel tests" OFF)
OPTION(FEEL_ENABLE_ALL "enable all feel modules" OFF)

if ( FEEL_ENABLE_ALL )
  set( FEEL_ENABLE_DOCUMENTATION ON )
  set( FEEL_ENABLE_BENCHMARKS ON )
  set( FEEL_ENABLE_EXAMPLES ON )
  set( FEEL_ENABLE_APPLICATIONS ON )
  set( FEEL_ENABLE_RESEARCH ON )
  set( FEEL_ENABLE_TESTS ON )
endif( FEEL_ENABLE_ALL )

OPTION(FEEL_MINIMAL_CONFIGURATION "enable feel minimal configuration" OFF)
IF( FEEL_MINIMAL_CONFIGURATION )
  set( FEEL_ENABLE_DOCUMENTATION OFF )
  set( BUILD_TESTING OFF )
  set( FEEL_ENABLE_DOCUMENTATION ON )
  set( ENABLE_INSTANTIATION_MODE OFF )
  UNSET( FEEL_INSTANTIATION_MODE CACHE )
  SET(FEEL_MESH_MAX_ORDER "1" CACHE STRING "maximum geometrical order in templates to instantiate" FORCE )
ENDIF( FEEL_MINIMAL_CONFIGURATION )

#
# Enable testing
#
INCLUDE(CTest)
ENABLE_TESTING()

if ( FEEL_ENABLE_DOCUMENTATION )
  ADD_SUBDIRECTORY ( doc )
endif ( FEEL_ENABLE_DOCUMENTATION )

if ( FEEL_ENABLE_BENCHMARKS )
  ADD_SUBDIRECTORY ( benchmarks )
endif()

if ( FEEL_ENABLE_EXAMPLES )
 ADD_SUBDIRECTORY ( examples )
endif()

if ( FEEL_ENABLE_APPLICATIONS )
 ADD_SUBDIRECTORY ( applications )
elseif (EXISTS ${FEEL_SOURCE_DIR}/applications/opus )
  ADD_SUBDIRECTORY ( applications/opus )
endif()


if ( FEEL_ENABLE_RESEARCH )
  ADD_SUBDIRECTORY ( research )
endif()




IF(FEEL_ENABLE_TESTS )

  macro(feel_add_test testname)
    set(targetname test_${testname})
    set(filename test_${testname}.cpp)
    add_executable(${targetname} ${filename})
    target_link_libraries(${targetname} ${FEEL_LIBRARIES} ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} )
if ( APPLE )
    add_test(
      NAME test_${testname}
      COMMAND ${targetname}  # --log_level=message seems to trigger a segfault
      )
else( APPLE )
    add_test(
      NAME test_${testname}
      COMMAND ${targetname} --log_level=message
      )
endif ( APPLE )
  endmacro(feel_add_test)

  add_subdirectory( testsuite )

endif()

# generate configuration header
set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(FEEL_PREFIX ${CMAKE_INSTALL_PREFIX})
set(FEEL_DATADIR ${CMAKE_INSTALL_PREFIX}/share/feel )
CONFIGURE_FILE(feelconfig.h.in feel/feelconfig.h  @ONLY)
CONFIGURE_FILE(feelinfo.h.in feel/feelinfo.h  @ONLY)

#
# Packaging
#
INCLUDE(InstallRequiredSystemLibraries)


foreach(includedir feelcore feelalg feelmesh feelpoly feelfilters feeldiscr feelvf feelmaterial feelsystem )

=== benchmarks/CMakeLists.txt ===
project( feel-benchmarks )

# set(petsc_SOLVER_OPTIONS "-ksp_monitor -pc_type asm -pc_asm_blocks 2" )
#set(petsc_SOLVER_OPTIONS "-pc_type lu -pc_factor_mat_solver_package umfpack" )
set(petsc_SOLVER_OPTIONS "-pc_type lu" )

# When PETSc is compiled with external direct solvers (UMFPACK, SuperLU, etc.),
# they can be selected like this:
set(petsc_LU_SOLVER_OPTIONS " -pc_type lu " )
set(petsc_LU_UMFPACK_SOLVER_OPTIONS " -pc_type lu -pc_factor_mat_solver_package umfpack -ksp_monitor " )

set(petsc_JACOBI_SOLVER_OPTIONS " -pc_type jacobi" )

#
# By default, we use the following options (GMRES with ILU(6) preconditioner and
# RCMK renumbering):
set(petsc_ILU_SOLVER_OPTIONS " -pc_type ilu -pc_factor_levels 6 -pc_factor_mat_ordering rcm " )

macro(feel_add_bench examplename)

  set(targetname feel_bench_${examplename})
  set(filename ${examplename}.cpp)
  add_executable(${targetname} ${filename})
  target_link_libraries(${targetname} ${FEEL_LIBRARIES} )
endmacro(feel_add_bench)

foreach( DIR laplacian  navierstokes perf wrapper/python python )
  add_subdirectory( ${DIR} )
endforeach()

=== doc/CMakeLists.txt ===
ADD_SUBDIRECTORY( api )
ADD_SUBDIRECTORY( tutorial )

set(FEEL_INSTALL_APPS ${FEEL_INSTALL_APPS} PARENT_SCOPE)

=== examples/CMakeLists.txt ===
project( feel-examples )

macro(feel_add_example examplename)

  set(targetname feel_${examplename})
  set(filename ${examplename}.cpp)
  add_executable(${targetname} ${filename})
  target_link_libraries(${targetname} ${FEEL_LIBRARIES} )
endmacro(feel_add_example)

foreach( DIR generic heat solid snippets)
  add_subdirectory( ${DIR} )
endforeach()

=== feel/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8 -*-
#
#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-29
#
#  Copyright (C) 2009-2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

macro(feel_append_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(FEEL_SRCS ${FEEL_SRCS};${LIST} PARENT_SCOPE)
  set(FEEL_DIRS ${FEEL_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(feel_append_src)

add_subdirectory (feelcore)
add_subdirectory (feelalg)
add_subdirectory (feelmesh)
#add_subdirectory (feelpoly)
add_subdirectory (feeldiscr)
add_subdirectory (feelfilters)
add_subdirectory (feelmaterial)
add_subdirectory (feelvf )
#add_subdirectory (feelsystem)

add_library(feel++ SHARED options.cpp ${FEEL_SRCS})
set_target_properties( feel++ PROPERTIES VERSION ${FEEL_SHARED_VERSION} SOVERSION ${FEEL_SHARED_SOVERSION})

#target_link_libraries (feel++ ${PETSC_LIBRARIES} ${Boost_LIBRARIES} ${MPI_LIBRARIES} ${LIBXML2_LIBRARIES} ${TBB_LIBRARIES})
target_link_libraries (feel++ ${FEEL_LIBRARIES})
set_target_properties(feel++ PROPERTIES VERSION ${FEEL_SHARED_VERSION} SOVERSION ${FEEL_SHARED_SOVERSION})

GET_TARGET_PROPERTY(FEEL_LIBRARY feel++ LOCATION)

list(APPEND LIST_LIBS ${FEEL_LIBRARY})
if ( UNIX )
  list(APPEND LIST_LIBS "${FEEL_LIBRARY}.${FEEL_SHARED_VERSION}")
  list(APPEND LIST_LIBS "${FEEL_LIBRARY}.${FEEL_SHARED_SOVERSION}")
endif( )
set(FEEL_INSTALL_LIBS ${FEEL_INSTALL_LIBS};${LIST_LIBS} PARENT_SCOPE)

=== testsuite/CMakeLists.txt ===
###  CMakeLists.txt --- 

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-11-28
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
foreach( testdir core alg mesh poly filters material discr )
  add_subdirectory( feel${testdir} )
endforeach()

=== benchmarks/laplacian/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-12-01
#
#  Copyright (C) 2009 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

add_subdirectory( ale )
add_subdirectory( cG )

# foreach( BENCH
#     nonlinearpow
#     ale1 ale2 ale3 ale4 ale5 )

#     feel_add_bench( ${BENCH} )

#     # test each backend
#     foreach( BACKEND petsc trilinos )
#       add_test( feel_bench_${BENCH}-${BACKEND}
#         ${FEEL_SOURCE_DIR}/benchmarks/python/batch_validation.py
#         --program=${targetname}
#         --mode=0
#         --path=${FEEL_BUILD_DIR}/benchmarks/convergence/
#         --cmdargs="--backend=${BACKEND} --export=0 ${${BACKEND}_LU_SOLVER_OPTIONS}" )
#     endforeach()

# endforeach()

=== benchmarks/navierstokes/CMakeLists.txt ===
###  TEMPLATE.txt.tpl; coding: utf-8 ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2011-04-02
#
#  Copyright (C) 2011 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
foreach( DIR poiseuille kovasznay turek)
  add_subdirectory( ${DIR} )
endforeach()

=== benchmarks/perf/CMakeLists.txt ===
###  CMakeLists.txt ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2009-12-01
#
#  Copyright (C) 2009 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

add_executable( feel_perf
  bench1_main.cpp
  bench1_run.cpp
  bench1_run1d.cpp
  bench1_run2d.cpp
  bench1_run3d.cpp
  )
target_link_libraries(feel_perf ${FEEL_LIBRARIES} )
# add_test( perf COMMAND feel_perf --hsi

add_executable( feel_perf2
  perf2.cpp
  )
target_link_libraries(feel_perf2 ${FEEL_LIBRARIES} )

=== benchmarks/python/CMakeLists.txt ===
###  TEMPLATE.txt.tpl; coding: utf-8 ---

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2010-12-05
#
#  Copyright (C) 2010 Universit Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#FILE(COPY *.py DESTINATION ${CMAKE_BINARY_DIR})

=== cmake/modules/CMakeLists.txt ===
###  CMakeLists.txt; coding: utf-8 --- 

#  Author(s): Christophe Prud'homme <christophe.prudhomme@ujf-grenoble.fr>
#       Date: 2010-12-31
#
#  Copyright (C) 2010 Université Joseph Fourier (Grenoble I)
#
# Distributed under the GPL(GNU Public License):
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

set(modules 
  FindFeel++.cmake  
  FindEigen2.cmake  
  FindMetis.cmake   
  FindOpenTURNS.cmake         
  FindPETSc.cmake
  FindSLEPc.cmake
  FindTrilinos.cmake
  UseDoxygen.cmake
  FindMadLib.cmake
  FindOctave.cmake
  FindPackageMultipass.cmake
  FindReadline.cmake
  FindTBB.cmake
  ResolveCompilerPaths.cmake
  UseLATEX.cmake )

INSTALL(FILES ${modules} DESTINATION share/feel/cmake/modules COMPONENT Devel)

=== contrib/eigen/CMakeLists.txt ===
project(Eigen)

cmake_minimum_required(VERSION 2.6.2)

# guard against in-source builds

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "In-source builds not allowed. Please make a new directory (called a build directory) and run CMake from there. You may need to remove CMakeCache.txt. ")
endif()

# guard against bad build-type strings

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_tolower)
if(    NOT cmake_build_type_tolower STREQUAL "debug"
   AND NOT cmake_build_type_tolower STREQUAL "release"
   AND NOT cmake_build_type_tolower STREQUAL "relwithdebinfo")
  message(FATAL_ERROR "Unknown build type \"${CMAKE_BUILD_TYPE}\". Allowed values are Debug, Release, RelWithDebInfo (case-insensitive).")
endif()


#############################################################################
# retrieve version infomation                                               #
#############################################################################

# automatically parse the version number
file(READ "${PROJECT_SOURCE_DIR}/Eigen/src/Core/util/Macros.h" _eigen_version_header)
string(REGEX MATCH "define[ \t]+EIGEN_WORLD_VERSION[ \t]+([0-9]+)" _eigen_world_version_match "${_eigen_version_header}")
set(EIGEN_WORLD_VERSION "${CMAKE_MATCH_1}")
string(REGEX MATCH "define[ \t]+EIGEN_MAJOR_VERSION[ \t]+([0-9]+)" _eigen_major_version_match "${_eigen_version_header}")
set(EIGEN_MAJOR_VERSION "${CMAKE_MATCH_1}")
string(REGEX MATCH "define[ \t]+EIGEN_MINOR_VERSION[ \t]+([0-9]+)" _eigen_minor_version_match "${_eigen_version_header}")
set(EIGEN_MINOR_VERSION "${CMAKE_MATCH_1}")
set(EIGEN_VERSION_NUMBER ${EIGEN_WORLD_VERSION}.${EIGEN_MAJOR_VERSION}.${EIGEN_MINOR_VERSION})

# if the mercurial program is absent, this will leave the EIGEN_HG_CHANGESET string empty,
# but won't stop CMake.
execute_process(COMMAND hg tip -R ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE EIGEN_HGTIP_OUTPUT)
execute_process(COMMAND hg branch -R ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE EIGEN_BRANCH_OUTPUT)

# if this is the default (aka development) branch, extract the mercurial changeset number from the hg tip output...
if(EIGEN_BRANCH_OUTPUT MATCHES "default")
string(REGEX MATCH "^changeset: *[0-9]*:([0-9;a-f]+).*" EIGEN_HG_CHANGESET_MATCH "${EIGEN_HGTIP_OUTPUT}")
set(EIGEN_HG_CHANGESET "${CMAKE_MATCH_1}")
endif(EIGEN_BRANCH_OUTPUT MATCHES "default")
#...and show it next to the version number
if(EIGEN_HG_CHANGESET)
  set(EIGEN_VERSION "${EIGEN_VERSION_NUMBER} (mercurial changeset ${EIGEN_HG_CHANGESET})")
else(EIGEN_HG_CHANGESET)
  set(EIGEN_VERSION "${EIGEN_VERSION_NUMBER}")
endif(EIGEN_HG_CHANGESET)


include(CheckCXXCompilerFlag)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#############################################################################
# find how to link to the standard libraries                                #
#############################################################################

find_package(StandardMathLibrary)

set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "")

if(NOT STANDARD_MATH_LIBRARY_FOUND)

  message(FATAL_ERROR
    "Can't link to the standard math library. Please report to the Eigen developers, telling them about your platform.")

else()

  if(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO)
    set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "${EIGEN_STANDARD_LIBRARIES_TO_LINK_TO} ${STANDARD_MATH_LIBRARY}")
  else()
    set(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO "${STANDARD_MATH_LIBRARY}")
  endif()

endif()

if(EIGEN_STANDARD_LIBRARIES_TO_LINK_TO)
  message(STATUS "Standard libraries to link to explicitly: ${EIGEN_STANDARD_LIBRARIES_TO_LINK_TO}")
else()
  message(STATUS "Standard libraries to link to explicitly: none")
endif()

option(EIGEN_BUILD_BTL "Build benchmark suite" OFF)
if(NOT WIN32)
  option(EIGEN_BUILD_PKGCONFIG "Build pkg-config .pc file for Eigen" ON)
endif(NOT WIN32)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

option(EIGEN_SPLIT_LARGE_TESTS "Split large tests into smaller executables" ON)

option(EIGEN_DEFAULT_TO_ROW_MAJOR "Use row-major as default matrix storage order" OFF)
if(EIGEN_DEFAULT_TO_ROW_MAJOR)
  add_definitions("-DEIGEN_DEFAULT_TO_ROW_MAJOR")
endif()

add_definitions("-DEIGEN_PERMANENTLY_DISABLE_STUPID_WARNINGS")

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -Wwrite-strings -Wformat-security -fexceptions -fno-check-new -fno-common -fstrict-aliasing")
  set(CMAKE_CXX_FLAGS_DEBUG "-g3")
  set(CMAKE_CXX_FLAGS_RELEASE "-g0 -O2")

  check_cxx_compiler_flag("-Wno-variadic-macros" COMPILER_SUPPORT_WNOVARIADICMACRO)
  if(COMPILER_SUPPORT_WNOVARIADICMACRO)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-variadic-macros")
  endif()

  check_cxx_compiler_flag("-Wextra" COMPILER_SUPPORT_WEXTRA)
  if(COMPILER_SUPPORT_WEXTRA)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")

  option(EIGEN_TEST_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
    message(STATUS "Enabling SSE2 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE3 "Enable/Disable SSE3 in tests/examples" OFF)
  if(EIGEN_TEST_SSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse3")
    message(STATUS "Enabling SSE3 in tests/examples")
  endif()

  option(EIGEN_TEST_SSSE3 "Enable/Disable SSSE3 in tests/examples" OFF)
  if(EIGEN_TEST_SSSE3)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
    message(STATUS "Enabling SSSE3 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE4_1 "Enable/Disable SSE4.1 in tests/examples" OFF)
  if(EIGEN_TEST_SSE4_1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    message(STATUS "Enabling SSE4.1 in tests/examples")
  endif()

  option(EIGEN_TEST_SSE4_2 "Enable/Disable SSE4.2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE4_2)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
    message(STATUS "Enabling SSE4.2 in tests/examples")
  endif()

  option(EIGEN_TEST_ALTIVEC "Enable/Disable AltiVec in tests/examples" OFF)
  if(EIGEN_TEST_ALTIVEC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec -mabi=altivec")
    message(STATUS "Enabling AltiVec in tests/examples")
  endif()

  option(EIGEN_TEST_NEON "Enable/Disable Neon in tests/examples" OFF)
  if(EIGEN_TEST_NEON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfloat-abi=softfp -mfpu=neon -mcpu=cortex-a8")
    message(STATUS "Enabling NEON in tests/examples")
  endif()

  check_cxx_compiler_flag("-fopenmp" COMPILER_SUPPORT_OPENMP)
  if(COMPILER_SUPPORT_OPENMP)
    option(EIGEN_TEST_OPENMP "Enable/Disable OpenMP in tests/examples" OFF)
    if(EIGEN_TEST_OPENMP)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp")
      message(STATUS "Enabling OpenMP in tests/examples")
    endif()
  endif()

endif(CMAKE_COMPILER_IS_GNUCXX)

if(MSVC)
  # C4127 - conditional expression is constant
  # C4714 - marked as __forceinline not inlined (I failed to deactivate it selectively)
  #         We can disable this warning in the unit tests since it is clear that it occurs
  #         because we are oftentimes returning objects that have a destructor or may
  #         throw exceptions - in particular in the unit tests we are throwing extra many
  #         exceptions to cover indexing errors.
  # C4505 - unreferenced local function has been removed (impossible to deactive selectively)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /wd4127 /wd4505 /wd4714")

  # replace all /Wx by /W4
  string(REGEX REPLACE "/W[0-9]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  check_cxx_compiler_flag("/openmp" COMPILER_SUPPORT_OPENMP)
  if(COMPILER_SUPPORT_OPENMP)
    option(EIGEN_TEST_OPENMP "Enable/Disable OpenMP in tests/examples" OFF)
    if(EIGEN_TEST_OPENMP)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /openmp")
      message(STATUS "Enabling OpenMP in tests/examples")
    endif()
  endif()

  option(EIGEN_TEST_SSE2 "Enable/Disable SSE2 in tests/examples" OFF)
  if(EIGEN_TEST_SSE2)
    if(NOT CMAKE_CL_64)
      # arch is not supported on 64 bit systems, SSE is enabled automatically.
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
    endif(NOT CMAKE_CL_64)
    message(STATUS "Enabling SSE2 in tests/examples")
  endif(EIGEN_TEST_SSE2)
endif(MSVC)

option(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION "Disable explicit vectorization in tests/examples" OFF)
option(EIGEN_TEST_X87 "Force using X87 instructions. Implies no vectorization." OFF)
option(EIGEN_TEST_32BIT "Force generating 32bit code." OFF)

if(EIGEN_TEST_X87)
  set(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION ON)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=387")
    message(STATUS "Forcing use of x87 instructions in tests/examples")
  else()
    message(STATUS "EIGEN_TEST_X87 ignored on your compiler")
  endif()
endif()

if(EIGEN_TEST_32BIT)
  if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
    message(STATUS "Forcing generation of 32-bit code in tests/examples")
  else()
    message(STATUS "EIGEN_TEST_32BIT ignored on your compiler")
  endif()
endif()

if(EIGEN_TEST_NO_EXPLICIT_VECTORIZATION)
  add_definitions(-DEIGEN_DONT_VECTORIZE=1)
  message(STATUS "Disabling vectorization in tests/examples")
endif()

option(EIGEN_TEST_NO_EXPLICIT_ALIGNMENT "Disable explicit alignment (hence vectorization) in tests/examples" OFF)
if(EIGEN_TEST_NO_EXPLICIT_ALIGNMENT)
  add_definitions(-DEIGEN_DONT_ALIGN=1)
  message(STATUS "Disabling alignment in tests/examples")
endif()

option(EIGEN_TEST_C++0x "Enables all C++0x features." OFF)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

# the user modifiable install path for header files
set(EIGEN_INCLUDE_INSTALL_DIR "include/feel" CACHE PATH "The directory where we install the header files (optional)")

# set the internal install path for header files which depends on wether the user modifiable
# EIGEN_INCLUDE_INSTALL_DIR has been set by the user or not.
if(EIGEN_INCLUDE_INSTALL_DIR)
  set(INCLUDE_INSTALL_DIR
    "include/feel"
    CACHE INTERNAL
    "The directory where we install the header files (internal)"
  )
else()
  set(INCLUDE_INSTALL_DIR
    "${CMAKE_INSTALL_PREFIX}/include/feel"
    CACHE INTERNAL
    "The directory where we install the header files (internal)"
  )
endif()

# similar to set_target_properties but append the property instead of overwriting it
macro(ei_add_target_property target prop value)

  get_target_property(previous ${target} ${prop})
  # if the property wasn't previously set, ${previous} is now "previous-NOTFOUND" which cmake allows catching with plain if()
  if(NOT previous)
    set(previous "")
  endif(NOT previous)
  set_target_properties(${target} PROPERTIES ${prop} "${previous} ${value}")
endmacro(ei_add_target_property)

install(FILES
  signature_of_eigen3_matrix_library
  DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel
  )

if(EIGEN_BUILD_PKGCONFIG)
    configure_file(eigen3.pc.in eigen3.pc)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/eigen3.pc
        DESTINATION share/pkgconfig
        )
endif(EIGEN_BUILD_PKGCONFIG)

add_subdirectory(Eigen)

add_subdirectory(doc EXCLUDE_FROM_ALL)

# add_custom_target(buildtests)
# add_custom_target(check COMMAND "ctest")
# add_dependencies(check buildtests)

# CMake/Ctest does not allow us to change the build command,
# so we have to workaround by directly editing the generated DartConfiguration.tcl file
# save CMAKE_MAKE_PROGRAM
set(CMAKE_MAKE_PROGRAM_SAVE ${CMAKE_MAKE_PROGRAM})
# and set a fake one
set(CMAKE_MAKE_PROGRAM "@EIGEN_MAKECOMMAND_PLACEHOLDER@")

# include(CTest)
# enable_testing() # must be called from the root CMakeLists, see man page
# include(EigenTesting)
# ei_init_testing()

# # overwrite default DartConfiguration.tcl
# # The worarounds are different for each version of the MSVC IDE

=== debian/changelog ===
feel++ (0.91.0~svn7063-2) unstable; urgency=low

  * debian/rules: re-enabled lam on sparc, hopefully fixing build on sparc
  * Fixed issue with g++-4.6 miscompilation (Closes: #625093).

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 16 May 2011 23:39:20 +0200

feel++ (0.91.0~svn7063-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 16 May 2011 17:13:56 +0200

feel++ (0.91.0~svn7044-1) unstable; urgency=low

  [Christophe Prud'homme]
  * New upstream release
  * debian/control: Updated standard-versions to 3.9.2 (no change)
  * debian/control: Added texlive-fonts-extra for manual to b-d
  * Switch to dpkg-source 3.0 (quilt) format

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 09 May 2011 23:31:49 +0200

feel++ (0.91.0~svn7013-2) unstable; urgency=low

  * debian/patches/manual.patch: try again to fix the latex font creation
    on some platforms

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 26 Apr 2011 05:56:22 +0200

feel++ (0.91.0~svn7013-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 24 Apr 2011 19:25:17 +0200

feel++ (0.91.0~svn7009-3) unstable; urgency=low

  * debian/rules: in Release mode, use -O2 instead of -O3 as the former
    use less memory and produces the same efficiency

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 24 Apr 2011 14:43:23 +0200

feel++ (0.91.0~svn7009-2) unstable; urgency=low

  * debian/control: apply ubuntu patch

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 24 Apr 2011 12:57:03 +0200

feel++ (0.91.0~svn7009-1) unstable; urgency=low

  * New upstream release
  * debian/patches:  removed patches, applied upstream

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 23 Apr 2011 23:49:32 +0200

feel++ (0.90.0-13) unstable; urgency=low

  * debian/control: libfeel++-dev update Depends

 -- Christophe Prud'homme <prudhomm@debian.org>  Wed, 20 Apr 2011 05:35:57 +0200

feel++ (0.90.0-12) unstable; urgency=low

  * debian/control: d-b on texlive-fonts-recommended to avoid font issues
    with pdflatex on some arches

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 19 Apr 2011 19:45:05 +0200

feel++ (0.90.0-11) unstable; urgency=low

  * debian/control: b-d on libslepc3.0.0 for testing
  * debian/patches: update minconf.patch to reduce even more the minimum
    configuration

 -- Christophe Prud'homme <prudhomm@debian.org>  Tue, 19 Apr 2011 17:17:06 +0200

feel++ (0.90.0-10) unstable; urgency=low

  * debian/control: added texlive-latex-recommended to fix manual
    compilation on some arch

 -- Christophe Prud'homme <prudhomm@debian.org>  Mon, 11 Apr 2011 20:57:24 +0200

feel++ (0.90.0-9) unstable; urgency=low

  * debian/control: depend on doxygen-latex and not on texlive-* packages
    anymore

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 10 Apr 2011 20:27:57 +0200

feel++ (0.90.0-8) unstable; urgency=low

  * debian/control: Fix tbb depends for non amd64/i386 arch (Closes: #620645).
  * fix feel-manual compilation

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 10 Apr 2011 09:57:26 +0200

feel++ (0.90.0-7) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/patches/minconf.patch: even more minimal configuration for low
    memory configuration

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 20 Mar 2011 21:41:20 +0100

feel++ (0.90.0-6) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/patches/s390.patches: fix for s390
  * debian/rules: tring minimal configuration for failing arches

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 19 Mar 2011 10:56:20 +0100

feel++ (0.90.0-5) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/control: build-depends on tbb only on amd64 and i386
  * debian/patches/sse.patch: remove sse options to build on non intel arches

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 18 Mar 2011 11:17:34 +0100

feel++ (0.90.0-4) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/control: tighten up build-depends to help building on more platforms

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 18 Mar 2011 07:56:02 +0100

feel++ (0.90.0-3) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/{control,rules}: use quilt

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 18 Mar 2011 06:53:33 +0100

feel++ (0.90.0-2) unstable; urgency=low

  [Christophe Prud'homme]
  * debian/patches/feelgeo: fix compilation in buildd

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 17 Mar 2011 21:41:36 +0100

feel++ (0.90.0-1) unstable; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Thu, 17 Mar 2011 11:52:26 +0100

feel++ (0.90.0~svn6918-1) experimental; urgency=low

  [ Christophe Prud'homme ]
  * New upstream release
  * debian/control: fix lintian warnings

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 20 Feb 2011 17:28:51 +0100

feel++ (0.90.0~svn6917-1) experimental; urgency=low

  [ Christophe Prud'homme ]
  * New upstream release
  * debian/control: update slepc deps to 3.1

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 20 Feb 2011 10:13:13 +0100

feel++ (0.90.0~svn6901-1) experimental; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sat, 29 Jan 2011 11:36:01 +0100

feel++ (0.90.0~svn6893-1) experimental; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 16 Jan 2011 12:59:48 +0100

feel++ (0.90.0~svn6877-1) experimental; urgency=low

  * New upstream release

 -- Christophe Prud'homme <prudhomm@debian.org>  Sun, 02 Jan 2011 22:49:39 +0100

feel++ (0.90.0~svn6870-1) experimental; urgency=low

  [Christophe Prud'homme]
  * Feel++ is near release 0.90.0
  * Life was renamed Feel++ and Feel++ package will replace Life package

 -- Christophe Prud'homme <prudhomm@debian.org>  Fri, 31 Dec 2010 17:39:18 +0100

=== debian/control ===
Source: feel++
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>
Build-Depends: cdbs, quilt, debhelper (>= 7), cmake (>=2.6), g++-4.5, gfortran (>=4.4),
	       libboost-all-dev, libboost-mpi-dev,
	       mpi-default-dev[!hurd-i386], mpi-default-bin[!hurd-i386],
	       libtrilinos-dev[!armel !mips !mipsel !s390 !hppa !hurd-i386 !sparc],
	       libpetsc3.1-dev (>= 3.1.dfsg-3), libslepc3.1-dev[amd64 i386] | libslepc3.0.0-dev [amd64 i386],
	       libhdf5-mpi-dev,
	       libsuperlu3-dev, libsuitesparse-dev, libscotchmetis-dev,
	       python-pyx, python-scipy,
	       libxml2-dev,
	       gmsh, 
               doxygen, doxygen-latex,
	       transfig,imagemagick,
	       libtbb-dev[amd64 i386],
	       libopenturns-dev, openturns-wrapper, libann-dev, libglpk-dev, octave3.2-headers
Standards-Version: 3.9.2
Homepage: http://www.feelpp.org
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/feel++/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/feel++/trunk


Package: libfeel++1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gmsh, mpi-default-bin
Replaces: liblife
Description: A library for the finite element method
 This package provides the dynamic Feel++ libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration


Package: libfeel++-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++1 (= ${binary:Version}), libvtk5-dev, 
	 libboost1.46-all-dev|libboost-all-dev, libboost-mpi1.46-dev |libboost-mpi-dev,
	 mpi-default-dev, mpi-default-bin,
         libtrilinos-dev, libpetsc3.1-dev (>= 3.1.dfsg-3), libslepc3.1-dev (>= 3.1) | libslepc3.0.0-dev (>= 3.0), libgmm++-dev,
         libsuperlu3-dev, libsuitesparse-dev, libscotchmetis-dev,
	 libeigen2-dev, libvtk5-dev, libxml2-dev, libtbb-dev [amd64 i386],
         libopenturns-dev, openturns-wrapper, libann-dev, libglpk-dev, octave3.2-headers
Suggests: feel++-doc, libfeel++-dbg, doxygen
Replaces: liblife-dev
Description: A library for the finite element method
 This package provides the header files and static libraries.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: libfeel++-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++-dev, libtbb2-dbg [amd64 i386]
Replaces: liblife-dbg
Description: A library for the finite element method
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-apps
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfeel++1 (= ${binary:Version}), gmsh
Recommends: paraview
Replaces: life-apps
Description: A library for the finite element method
 This package provides some applications codes(source and executables) such
 as laplacian with cG and dG methods, stokes, heat transfer, solid
 mechanics(static and dynamic).
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

Package: feel++-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: life-doc
Description: A library for the finite element method
 This package provides the documentation for the Feel++ library : a user
 guide including a tutorial and the api documentation generated by
 doxygen.
 .
 Feel++ is a versatile finite element library to solve partial
 differential equations.
 .
 Support 1D, 2D, 3D
 .
 Support the following basic entities: simplices (segment, triangle,
 tetrahedron) and product of simplices (quadrangle, hexahedron)
 .
 Support various point sets on these basic entities: equispaced
 points, quadrature points, interpolation points (Gauss-Lobatto,
 Fekete, WarpBlend?)
 .
 Support continuous and discontinuous Galerkin methods
 .
 Support various polynomial sets:
 .
  * Lagrange(continuous,discontinuous,all dimensions,all interpolation
 point sets)
 .
  * Dubiner(discontinuous), boundary adapted(continuous)
 .
  * Legendre(discontinuous), boundary adapted(continuous)
 .
 Provide mathematical concept for higher order abstraction (Function
 spaces and associated elements, forms and operators)
 .
 Provide a language embedded in C++ for variational formulations,
 projection and numerical integration

=== debian/rules ===
#!/usr/bin/make -f

DEB_AUTO_CLEANUP_RCS   := yes
DEB_COMPRESS_EXCLUDE   := .pdf

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk


export CFLAGS=
export CXXFLAGS=

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_DOCUMENTATION=ON

ifeq "$(DEB_BUILD_ARCH)" "powerpc"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif
ifeq "$(DEB_BUILD_ARCH)" "alpha"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif
ifeq "$(DEB_BUILD_ARCH)" "s390"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif
ifeq "$(DEB_BUILD_ARCH)" "armel"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif
ifeq "$(DEB_BUILD_ARCH)" "mips"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif
ifeq "$(DEB_BUILD_ARCH)" "mipsel"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
endif

ifeq "$(DEB_BUILD_ARCH)" "sparc"
FEEL_MPI=-DMPI_COMPILER=/usr/bin/mpic++.lam \
         -DMPI_LIBRARY="MPI_LIBRARY-NOTFOUND"
FEEL_INSTALL_ENABLERS=-DFEEL_ENABLE_ALL=OFF                \
                      -DBUILD_TESTING=OFF                  \
                      -DFEEL_MINIMAL_CONFIGURATION=ON
else
FEEL_MPI=
endif
DEB_CMAKE_EXTRA_FLAGS=                      \
        -DCMAKE_BUILD_TYPE=Release          \
	-DCMAKE_CXX_FLAGS_RELEASE="-O2 -DNDEBUG -g0"  \
	-DCMAKE_CXX_COMPILER=/usr/bin/g++-4.5\
	-DPETSC_ARCH=linux-gnu-c-opt        \
	-DPETSC_DIR=/usr/lib/petscdir/3.1 \
	-DPETSC_EXECUTABLE_RUNS=ON          \
	${FEEL_MPI}                         \
	${FEEL_INSTALL_ENABLERS}            \
	-DTRILINOS_LIB_NOXLAPACK=           \
        -DENABLE_INSTANTIATION_MODE=OFF

#build/feel++-apps::
#	-cd $(DEB_BUILDDIR) && ctest -D Experimental

build/libfeel++::
	-cd $(DEB_BUILDDIR) && cmake ..

build/feel++-doc::
	-cd $(DEB_BUILDDIR)/doc/api && make doxygen

binary-install/feel++-apps::
	strip debian/feel++-apps/usr/bin/*

get-orig-source:
	uscan --force-download
